#include <iostream>

using namespace std;

int main()
{
    int N, Q;
    cin >>N;
    cin >>Q;
    int a[N+1][2], brpl=0, brojac=0, rez=0, k[Q];
    a[0][0]=0;
    a[0][1]=0;
    for(int i=1; i<N+1; i++){
        cin >>a[i][0];
        cin >>a[i][1];
    }
    for(int i=0; i<Q; i++){
        cin >>k[i];
    }
    for(int i=0; i<N+1; i++){
        brpl=brpl+a[i][1];
        if (k[brojac]<a[i+1][0]){
             while(k[brojac]<a[i+1][0]){
                    if(k[brojac]-a[i][0]>=brpl){
                        rez=rez+brpl;
                        brpl=0;
                        cout<<rez<<endl;
                    }
                    else{
                        rez=rez+k[brojac]-a[i][0]+1;
                        brpl=brpl-k[brojac]+a[i][0]-1;
                        cout<<rez<<endl;
                    }
                brojac=brojac+1;
            }
        }
       else{
            if(a[i+1][0]-a[i][0]>=brpl){
                    rez=rez+brpl;
                    brpl=0;
                }
            else{
                    rez=rez+a[i+1][0]-a[i][0]+1;
                    brpl=brpl-a[i+1][0]+a[i][0]-1;
                }
       }
    }

}